// Mike Woodring
// Bear Canyon Consulting LLC
// http://www.bearcanyon.com
//
using System;
using System.Threading;
using System.Security;
using System.Security.Principal;
using System.Runtime.Remoting;

class Calc : MarshalByRefObject, ICalc
{
    public int Add( int a, int b )
    {
        Console.WriteLine("Adding {0} and {1}", a, b);

        IPrincipal principal = Thread.CurrentPrincipal;
        string principalName = principal.Identity.Name;
        if( principalName == string.Empty )
            principalName = "n/a";
        
        Console.WriteLine("Identity: {0}", principalName);
        Console.WriteLine("AuthenticationType: {0}", principal.Identity.AuthenticationType);

        string[] roles = { "Sex Symbols", ".\\VS Developers",
                           "Everyone", "NT AUTHORITY\\Authenticated Users" };

        foreach( string role in roles )
        {
            Console.WriteLine("IsInRole({0}): {1}", role, principal.IsInRole(role));
        }

        return(a + b);
    }
}

class Server
{
    static void Main(string[] args)
    {
        RemotingConfiguration.Configure(AppDomain.CurrentDomain.BaseDirectory + "server.exe.config");
        Console.WriteLine("Server ready.");
        Console.ReadLine();
    }
}
